Contributing to Nucleus
=======================

Looking to contribute something to Nucleus? **Here's how you can help**.

Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved.


## Issues

The [issue tracker](https://github.com/AlexAltea/nucleus/issues) is the preferred channel for [bug reports](#bug-reports) and [features requests](#feature-requests), but please respect the following restrictions:

* Please **do not** use the issue tracker for personal support requests. The project is not ready to be used by end users. Take a look at the [Frequently Asked Questions](docs/user/faq.md) in the meantime.
* Please **do not** derail or troll issues. Keep the discussion on topic and respect the opinions of others.
* Please **do not** submit existing issues and avoid "*Me too.*"-like comments.

### Bug reports

A bug is a *demonstrable problem* that is caused by the code in the repository. Good bug reports are extremely helpful so please make sure you provide the following information:

1. Host operating system and hardware details.
2. Nucleus information.
    * Version (e.g. `v0.0.4`) and/or hash (e.g. `5f50b39`).
    * Settings (e.g. *Release*, *Debug*, etc.)
    * Target (e.g. `nucleus-android`, `nucleus-osx`, `nucleus-windows`, etc.)
3. Configuration file, i.e. `config.xml`.
4. If issue occurs during emulation, attach guest application file if copyright laws allow it. Otherwise, write down the guest application identifier, name and checksum.

### Feature requests

Feature requests are always welcome. Before opening one, please take a moment to find out whether your idea fits with the scope and aims of the project. Please verify that your idea is not already referenced in the [Roadmap](docs/development/roadmap.md).


## Pull requests

**Please ask first** before embarking on any significant pull request (e.g. implementing features, refactoring code, adding new frontends), otherwise you risk spending a lot of time working on something that the might be rejected while reviewing.

Check the following documents:

* [Roadmap](docs/development/roadmap.md): Planned tasks that you can contribute to.
* [Conventions](docs/development/conventions.md): Coding style and conventions to follow.
* [Overview](docs/development/overview.md): Details about how the project is structured.
