Nucleus Documentation
=====================

The documentation is divided in the following three sections:

* [__Development__](development): Roadmap, style, acknowledgements and other informations about this repository.
    * [Conventions](development/conventions.md): Some coding-style guidelines.
    * [Overview](development/conventions.md): Layout of the code base.
    * [Roadmap](development/roadmap.md): Planned features.
* [__Technical__](technical): Documentation about the hardware and software that Nucleus emulates.
    * [PlayStation 3](technical/ps3):
        * [CPU documentation](technical/ps3/cpu.md): Cell Broadband Engine Architecture.
        * [GPU documentation](technical/ps3/gpu.md): Reality Synthesizer (RSX).
        * [System documentation](technical/ps3/system.md): Cell OS Lv-1 and Cell OS Lv-2.
* [__User__](user): Guides for potential end-users about how to configure Nucleus.
    * [FAQ](user/faq.md): Frequently Asked Questions.
    * [Keys](user/keys.md): Loading a keyvault file to decrypt applications.
